/***********************************************\
* 	UNIX Password Cracker	            		*
*	Network Security - 09/10		            *
*						                        *
*	Authors:				                    *
*		Victor Ruben Lacort Pellicer	        *
*		Sapnah Virendra			                *
*						                        *
\***********************************************/


#include <stdio.h> 
#include <crypt.h> 
#include <string.h>
#define MAX_PASS 30

int main(int argc, char* argv[])
{
	FILE *fin, *fout;		/* fin is the input file (passwd file), fout is the output file (cracked password and login) */
	FILE *fwlist;			/* fwlist is the wordlist file */
	char  login[MAX_PASS][15];	/* list of logins from the file */
	char  hash [MAX_PASS][15];	/* list of hashes from the file */
	char  crack[MAX_PASS][15];	/* list of logins already cracked from "result" file */
	char  salt [MAX_PASS][3];	/* list of salts from the file, the two firsts characters of each hash */
	int   exist[MAX_PASS];		/* if this login has to be cracked (1) or not (0) */
	int   mode;			/* 0 means incremental mode, 1 means dictionary attack, 2 means both, -1 means error/exit */

	int i, n_pass = 0, guess = 0;	/* i: iterator. n_pass: count of passwords in the file. guess: count of cracked passwords in current session */
	int round = 0;			/* round: variable to countdown number of characters in incremental mode */

	char  passwd[9];		/* where we store the password being tested */
	char* filename;			/* file name of passwd file */
	char* ptr;
	char  temp[1024];		/* temporal variable used for reading from files */

	if(argc == 1)			/* how to use */
	{
		fprintf(stdout, "\nUSE:\n%s password_file_name [OPTIONS]\n", argv[0]);
		fprintf(stdout, "OPTIONS (only one of them):\n-incremental | -wordlist wordlist_file_name\n\n");
		mode = -1;
	}
	else if(argc == 2)		/* incremental and default wordlist modes */
	{
		filename = argv[1];
		mode = 2;
		if( (fwlist = fopen("pru.lst", "r")) == NULL )
		{
			fprintf(stderr, "\nCould not open the default wordlist file: all.lst\n");
			mode = 0;
		}
	}
	else if(argc == 3)		/* incremental mode only */
	{
		filename = argv[1];
		if (strcmp(argv[2], "-incremental") == 0)
			mode = 0;
		else
			mode = -1;
	}
	else if(argc == 4)		/* specified wordlist mode only*/
	{
		filename = argv[1];
		if (strcmp(argv[2], "-wordlist") == 0)
		{
			mode = 1;
			if( (fwlist = fopen(argv[3], "r")) == NULL )
			{
				fprintf(stderr, "\nCould not open the specified wordlist file: %s\n", argv[3]);
				mode = -1;
			}
		}
		else
			mode = -1;
	}
	else
	{
		fprintf(stdout, "\nERROR!!!! Too many arguments...\n");
		fprintf(stdout, "\nUSAGE:\n%s password_file_name [OPTIONS]\n", argv[0]);
		fprintf(stdout, "OPTIONS (only one of them):\n-incremental | -wordlist wordlist_file_name\n\n");
		mode = -1;
	}

	if (mode >= 0)
	{
		if( (fin = fopen(filename, "r")) == NULL )
			fprintf(stderr, "\nCould not open the password file: %s\n", filename);
		else
		{
			for(i = 0; i < MAX_PASS; i++) exist[i] = 0;		/* initially we don't know how much passwords we have */

			for (i = 0; i < MAX_PASS; i++)				/* begin loading logins and hashes */
			{
				if(!feof(fin))
				{
					fgets(temp, 1024, fin);
					ptr = strtok(temp,":");
					strcpy(login[i], ptr);
					if ( (ptr = strtok (NULL, ":") ) != NULL )
						strcpy(hash[i], ptr);
					n_pass++;					/* count another password to crack */
				}
			}

			fclose(fin);

			for(i = 0; i < n_pass; i++)
			{
				salt[i][0] = hash[i][0];	/* extracting the salt from the hash */
				salt[i][1] = hash[i][1];
				salt[i][2] = '\0';

				exist[i]   = 1;			/* marking the password to be cracked */
			}
			fprintf(stdout, "\nLoaded %d logins and hashed passwords for being attacked.\n", n_pass);

		}

		if (mode == 0)
		{
			for (i = 0; i < 8; i++) passwd[i] = (char) 33;		/* we will use charset from (char)33 to (char)127 */
			passwd[9] = '\0';
		}
		

		if (n_pass > 0)			/* if we have passwords to begin cracking... */
		{
			if( (fout = fopen("result", "w")) == NULL )
				fprintf(stderr, "\nCould not open the result file: result\n");
			else
			{
				while(mode >= 0)
				{
					if (mode > 0)
					{
						if (!feof(fwlist))
						{	
							do
							{
								fgets(temp, 1024, fwlist);
							}while ( (temp[0] == '#') && (!feof(fwlist)) );

							if ( (ptr = strtok (temp, "\n") ) != NULL )
								strcpy(passwd, ptr);

							passwd[8] = '\0';	 	/* truncate to 8 characters, avoiding crashes */
							
						}
						else					/* when finished wordlist file... */
						{
							if (mode == 1) mode = -1; 	/* if only dicionary attack mode selected, end and exit; */
							if (mode == 2)			/* if both modes selected, begin with incremental mode. */
							{
								mode = 0;
								for (i = 0; i < 8; i++) passwd[i] = (char) 33;
								passwd[9] = '\0';
							}
							fclose(fwlist);
						}
					}
					else					/* incremental mode. charset: from (char)33 to (char)127 */
					{					/* 8 characters length and downing */

						passwd[7-round]++;
						if ( (passwd[7-round] == (char)127) && (round <= 7) )
						{
							passwd[7-round] = (char)33;
							if (round == 7)
							{
								passwd[7-round] = '\0';
								round++;
							}
							if (round <= 6)passwd[6-round]++;
							if ( (passwd[6-round] == (char)127) && (round <= 6) )
							{
								passwd[6-round] = (char)33;
								if (round == 6)
								{
									passwd[7-round] = '\0';
									round++;
								}
								if (round <= 5)passwd[5-round]++;
								if ( (passwd[5-round] == (char)127) && (round <= 5) )
								{
									passwd[5-round] = (char)33;
									if (round == 5)
									{
										passwd[7-round] = '\0';
										round++;
									}
									if (round <= 4)passwd[4-round]++;
									if ( (passwd[4-round] == (char)127) && (round <= 4) )
									{
										passwd[4-round] = (char)33;
										if (round == 4)
										{
											passwd[7-round] = '\0';
											round++;
										}
										if (round <= 3)passwd[3-round]++;
										if ( (passwd[3-round] == (char)127) && (round <= 3) )
										{
											passwd[3-round] = (char)33;
											if (round == 3)
											{
												passwd[7-round] = '\0';
												round++;
											}
											if (round <= 2)passwd[2-round]++;
											if ( (passwd[2-round] == (char)127) && (round <= 2) )
											{
												passwd[2-round] = (char)33;
												if (round == 2)
												{
													passwd[7-round] = '\0';
													round++;
												}
												if (round <= 1)passwd[1-round]++;
												if ( (passwd[1-round] == (char)127) && (round <= 1) )
												{
													passwd[1-round] = (char)33;
													if (round == 1)
													{
														passwd[7-round] = '\0';
														round++;
													}
													if (round == 0)passwd[0]++;
													if ( (passwd[0] == (char)127) && (round == 0) )
													{
														passwd[0] = (char)33;
														passwd[7-round] = '\0';
														round++;
													}

												}

											}

										}

									}

								}

							}

						}
					}

					for (i = 0; i < n_pass; i++)
					{
						if(exist[i])		/* flag to know which passwords we have cracked yet */
						{
							if(strcmp(hash[i], crypt(passwd, salt[i])) == 0) /* hash = crypt(passwd, salt); */
							{
								exist[i] = 0;
								fprintf(fout,"%s:%s\n", login[i],passwd);
								fclose(fout);
								fout = fopen("result", "a");
								guess++; 					
								fprintf(stdout,"Guessed: %d - %s:%s\n", guess, login[i],passwd);
							}
						}
					}
				}
			}
		}
	}
	return 0;
}

